USE AdventureWorks2008R2
GO 
-- using function in the filter criteria

-- Create a covering index
CREATE INDEX IX_SalesOrderHeader ON Sales.SalesOrderHeader(OrderDate) INCLUDE (AccountNumber);

SET NOCOUNT ON
SET STATISTICS IO ON

DECLARE @AccountNumber NVARCHAR(15);

DECLARE @StartTime DATETIME
SET @StartTime = GETDATE()

SELECT @AccountNumber = AccountNumber
FROM Sales.SalesOrderHeaderEnlarged
WHERE YEAR(OrderDate) = 2003

PRINT 'Duration with function: ' + CAST(DATEDIFF(ms, @StartTime, GETDATE()) AS varchar(10)) + ' ms'

SET @StartTime = GETDATE()

SELECT @AccountNumber = AccountNumber
FROM Sales.SalesOrderHeaderEnlarged
WHERE OrderDate >= '2003-01-01' 
  AND OrderDate < '2004-01-01'

PRINT 'Duration without function: ' + CAST(DATEDIFF(ms, @StartTime, GETDATE()) AS varchar(10)) + ' ms'

SET STATISTICS IO OFF

DROP INDEX IX_SalesOrderHeader ON Sales.SalesOrderHeader