USE AdventureWorks2008R2;
GO

-- Catch all queries - Collect Actual execution plan
SET NOCOUNT ON;

SET STATISTICS IO ON;
DECLARE @OrderDate DATETIME;
DECLARE @AccountNumber AccountNumber;

DECLARE @StartTime DATETIME;

--Set @OrderDate = '2003-01-17';
SET @AccountNumber = N'10-4020-000118';
SET @StartTime = GETDATE();


SELECT AccountNumber, OrderDate, ProductID, SUM(OrderQty) 
FROM Sales.SalesOrderHeaderEnlarged
JOIN Sales.SalesOrderDetailEnlarged ON SalesOrderHeaderEnlarged.SalesOrderID = SalesOrderDetailEnlarged.SalesOrderID
WHERE (OrderDate >= @OrderDate OR @OrderDate IS NULL)
  AND (AccountNumber = @AccountNumber OR @AccountNumber IS NULL)
GROUP BY AccountNumber, OrderDate, ProductID;

PRINT 'Duration with catch all: ' + CAST(DATEDIFF(ms, @StartTime, getdate()) as varchar(10)) + ' ms';

SET @StartTime = GETDATE();

DECLARE @sql nvarchar(max);

SELECT @sql = 'SELECT AccountNumber, OrderDate, ProductID, SUM(OrderQty) 
FROM Sales.SalesOrderHeaderEnlarged
JOIN Sales.SalesOrderDetailEnlarged ON SalesOrderHeaderEnlarged.SalesOrderID = SalesOrderDetailEnlarged.SalesOrderID
WHERE 1=1
' + 
CASE 
	WHEN @OrderDate IS NOT NULL 
	 THEN 'AND (OrderDate >= @OrderDate)
' 
	ELSE '' 
END + 
CASE
	WHEN @AccountNumber IS NOT NULL
	 THEN 'AND (AccountNumber = @AccountNumber)
'
	ELSE '' 
END +
'GROUP BY AccountNumber, OrderDate, ProductID
';


EXEC sp_executesql 
			@sql, 
			N'@OrderDate datetime, @AccountNumber AccountNumber',
			@OrderDate = @OrderDate, @AccountNumber = @AccountNumber;
	
PRINT 'Duration with specific filter: ' + CAST(DATEDIFF(ms, @StartTime, getdate()) as varchar(10)) + ' ms';
