DBCC FREEPROCCACHE
DBCC DROPCLEANBUFFERS
GO
SET STATISTICS IO ON
SET STATISTICS TIME ON
GO

select OrderDate, 
		SUM(BikeSales) as BikeSales,
		SUM(ComponentSales) as ComponentSales,
		SUM(ClothingSales) as ClothingSales,
		SUM(AccessorySales) as AccessorySales
from
(
	select OrderDate, 
		isnull(( 
			select SUM(OrderQty) 
			from Sales.SalesOrderDetail
			join Production.Product on Product.ProductID = SalesOrderDetail.ProductID
			join Production.ProductSubcategory on Product.ProductSubcategoryID = ProductSubcategory.ProductSubcategoryID
			join Production.ProductCategory on ProductSubcategory.ProductCategoryID = ProductCategory.ProductCategoryID
			where ProductCategory.Name = 'Bikes'
			and SalesOrderDetail.SalesOrderID = SalesOrderHeader.SalesOrderID
		), 0) as BikeSales,
		isnull(( 
			select SUM(OrderQty) 
			from Sales.SalesOrderDetail
			join Production.Product on Product.ProductID = SalesOrderDetail.ProductID
			join Production.ProductSubcategory on Product.ProductSubcategoryID = ProductSubcategory.ProductSubcategoryID
			join Production.ProductCategory on ProductSubcategory.ProductCategoryID = ProductCategory.ProductCategoryID
			where ProductCategory.Name = 'Components'
			and SalesOrderDetail.SalesOrderID = SalesOrderHeader.SalesOrderID
		), 0) as ComponentSales,
		isnull(( 
			select SUM(OrderQty) 
			from Sales.SalesOrderDetail
			join Production.Product on Product.ProductID = SalesOrderDetail.ProductID
			join Production.ProductSubcategory on Product.ProductSubcategoryID = ProductSubcategory.ProductSubcategoryID
			join Production.ProductCategory on ProductSubcategory.ProductCategoryID = ProductCategory.ProductCategoryID
			where ProductCategory.Name = 'Clothing'
			and SalesOrderDetail.SalesOrderID = SalesOrderHeader.SalesOrderID
		), 0) as ClothingSales,
		isnull(( 
			select SUM(OrderQty) 
			from Sales.SalesOrderDetail
			join Production.Product on Product.ProductID = SalesOrderDetail.ProductID
			join Production.ProductSubcategory on Product.ProductSubcategoryID = ProductSubcategory.ProductSubcategoryID
			join Production.ProductCategory on ProductSubcategory.ProductCategoryID = ProductCategory.ProductCategoryID
			where ProductCategory.Name = 'Accessories'
			and SalesOrderDetail.SalesOrderID = SalesOrderHeader.SalesOrderID
		), 0) as AccessorySales
	from Sales.SalesOrderHeader
) tab
group by OrderDate
order by OrderDate



GO
SET STATISTICS IO OFF
SET STATISTICS TIME OFF
GO
DBCC FREEPROCCACHE
DBCC DROPCLEANBUFFERS
GO
SET STATISTICS IO ON
SET STATISTICS TIME ON
GO

select OrderDate, 
		SUM(CASE WHEN ProductCategory.Name = 'Bikes' THEN OrderQty ELSE 0 END) AS BikeSales,
		SUM(CASE WHEN ProductCategory.Name = 'Components' THEN OrderQty ELSE 0 END) AS ComponentsSales,
		SUM(CASE WHEN ProductCategory.Name = 'Clothing' THEN OrderQty ELSE 0 END) AS ClothingSales,
		SUM(CASE WHEN ProductCategory.Name = 'Accessories' THEN OrderQty ELSE 0 END) AS AccessorySales
from Sales.SalesOrderHeader
join Sales.SalesOrderDetail on SalesOrderDetail.SalesOrderID = SalesOrderHeader.SalesOrderID
join Production.Product on Product.ProductID = SalesOrderDetail.ProductID
join Production.ProductSubcategory on Product.ProductSubcategoryID = ProductSubcategory.ProductSubcategoryID
join Production.ProductCategory on ProductSubcategory.ProductCategoryID = ProductCategory.ProductCategoryID
group by OrderDate
order by OrderDate

GO
SET STATISTICS IO OFF
SET STATISTICS TIME OFF
GO
DBCC FREEPROCCACHE
DBCC DROPCLEANBUFFERS
GO
SET STATISTICS IO ON
SET STATISTICS TIME ON
GO
select OrderDate, isnull([Bikes], 0) AS BikeSales, isnull([Components], 0) AS ComponentsSales, isnull([Clothing], 0) AS ClothingSales, isnull([Accessories], 0) AS AccessorySales
from
(
select OrderDate, ProductCategory.Name, OrderQty
from Sales.SalesOrderHeader
join Sales.SalesOrderDetail on SalesOrderDetail.SalesOrderID = SalesOrderHeader.SalesOrderID
join Production.Product on Product.ProductID = SalesOrderDetail.ProductID
join Production.ProductSubcategory on Product.ProductSubcategoryID = ProductSubcategory.ProductSubcategoryID
join Production.ProductCategory on ProductSubcategory.ProductCategoryID = ProductCategory.ProductCategoryID
) as src
PIVOT
(
sum(OrderQty)
for Name IN ([Bikes], [Components], [Clothing], [Accessories])
) as pvt

GO
SET STATISTICS IO OFF
SET STATISTICS TIME OFF
GO
